%define sysconfdir /etc
%define apachever  1.3.27
%define opensslver 0.9.6

Summary:	The PHP scripting language.
Name:		php
Version:	4.2.3
Release:	1.3.0
Group:		Development/Languages
URL:		http://www.php.net/
Source0:	http://www.php.net/distributions/php-%{version}.tar.gz
Patch0:		php-4.0.5-php-ini-extensions-gd.diff
Patch1:		php-4.0.5-php-ini-extension_dir-gd.diff
Patch2:		php-4.2.1-php-ini-betterdefaults-gd-1.diff
Patch5:		php-4.0.6-no-uploads-gd-1.diff
Patch11:	php-4.0.6-fix-php-ini-gd-1.diff
Patch20:	php-4.2.3-mysql-security-fix-gd-1.diff
Patch21:	php-4.2.3-wordwrap-fix-gd-1.diff
Patch22:	php-4.2.3-injection-fix-gd-1.diff
Copyright:	PHP
BuildRoot:	%{_tmppath}/%{name}-%{version}-root
BuildPrereq:	apache-devel
ExcludeArch:	ia64

%description
PHP is an HTML-embeddable scripting language.  PHP offers built-in database
integration for several commercial and non-commercial database management
systems, so writing a database-enabled script with PHP is fairly simple.  The
most common use of PHP coding is probably as a replacement for CGI scripts.

################################################################################
### The 'mod_php' package.
################################################################################
%package -n mod_php
Summary: The PHP HTML-embedded scripting language for use with Apache.
Group: System Environment/Daemons
URL: http://www.php.net/
Prereq: webserver
Obsoletes: php3, phpfi
BuildPrereq: apache-devel
Prereq: php = %{version}-%{release}

%description -n mod_php
PHP is an HTML-embedded scripting language.  PHP attempts to make it
easy for developers to write dynamically generated web pages.  PHP
also offers built-in database integration for several commercial and
non-commercial database management systems, so writing a
database-enabled web page with PHP is fairly simple.  The most common
use of PHP coding is probably as a replacement for CGI scripts.  The
mod_php module enables the Apache web server to understand and process
the embedded PHP language in web pages.

This package contains PHP version 4.0.  You'll also need to install the
Apache web server.

################################################################################
### The 'php-mysql' package.
################################################################################
%package mysql
Group: Development/Languages
Prereq: php = %{version}-%{release}, perl
Summary: A module for PHP applications that use MySQL databases.
Provides: php_database
Obsoletes: mod_php3-mysql
BuildPrereq: MySQL-devel
Requires: MySQL

%description mysql
The php-mysql package contains a dynamic shared object that will add
MySQL database support to PHP.  MySQL is an object-relational database
management system.  PHP is an HTML-embeddable scripting language.  If
you need MySQL support for PHP applications, you will need to install
this package and the php or mod_php package.

################################################################################
### The 'php-imap' package.
################################################################################
%package imap
Group: Development/Languages
Prereq: php = %{version}-%{release}, perl
Requires: imap, pam
Summary: A module for PHP applications that use IMAP.
BuildPrereq: imap-devel

%description imap
The php-imap package contains a dynamic shared object that will add IMAP
(Internet Message Access Protocol) support to PHP. IMAP is a protocol
for retrieving, uploading, and manipulating e-mail messages on mail servers.
PHP is an HTML-embeddable scripting language.  If you need IMAP support
for PHP applications, you will need to install this package and the php


################################################################################
### SECTION:  prep
################################################################################
%prep
%setup -q
  cp Zend/LICENSE Zend/ZEND_LICENSE
#  ./buildconf
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch5 -p1
%patch11 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1

################################################################################
### SECTION:  build
################################################################################
%build
  CFLAGS="$RPM_OPT_FLAGS -fPIC"; export CFLAGS

  ###  Function used for building both php standalone and module.
  compile() {
	./configure \
		--prefix=%{_prefix} \
		--sysconfdir=/etc \
		--with-config-file-path=/etc \
		--disable-debug \
		--enable-pic \
		--enable-inline-optimization \
		--with-exec-dir=%{_bindir} \
		--with-regex=system \
		--with-gettext \
		--with-gdbm \
		--without-mysql \
		--with-xml \
		--with-zlib \
		--with-gd=/usr \
		--with-jpeg-dir=/usr \
		--enable-magic-quotes \
		--enable-safe-mode \
		--enable-sysvsem \
		--enable-sysvshm \
		--enable-track-vars \
		--enable-ftp \
		--enable-debug \
		--enable-calender \
		--enable-sockets \
		--enable-bcmath \
		--disable-pear \
		--disable-yp \
		--with-openssl \
		--enable-versioning \
		$*
	make
  }

  ###  Function used for building PHP modules.
  build_ext() {
	%{__cc} -fPIC -shared $RPM_OPT_FLAGS \
		-DCOMPILE_DL_`echo $1 | tr '[a-z]' '[A-Z]'` \
		-DHAVE_`echo $1 | tr '[a-z]' '[A-Z]'` \
		-I. -I./main -I`%{_sbindir}/apxs -q INCLUDEDIR` -I./Zend \
		-I/usr/include/freetype -I/usr/include/$1 \
		-I./ext/$1 -I./ext/$1/lib$1 \
		-I./ext/xml/expat/xmltok -I./ext/xml/expat/xmlparse \
		-I./TSRM \
		`grep ^CPPFLAGS Zend/Makefile | cut -f2- -d=` \
		$4 $2 -o $1.so -L.libs $3 -lc
  }


  ###  Build the standalone binary.
  compile --enable-force-cgi-redirect --enable-discard-path --enable-static
  cp php php_standalone
  make distclean

  ###  Build the apache module.
  compile --with-apxs=%{_sbindir}/apxs

  ###  Build the PHP modules.
  build_ext mysql ext/mysql/php_mysql.c "-L/usr/lib/mysql -lmysqlclient" "-DHAVE_MYSQL_MYSQL_H -DHAVE_MYSQL_REAL_CONNECT"
  build_ext imap ext/imap/php_imap.c "%{_libdir}/libc-client.a -lpam" "-DHAVE_IMAP2000"


################################################################################
### SECTION:  install
################################################################################
%install
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
  mkdir -p $RPM_BUILD_ROOT%{_libdir}/{apache,php/extensions}
  mkdir -p $RPM_BUILD_ROOT/etc/httpd
  mkdir -p $RPM_BUILD_ROOT%{_bindir}
  mkdir -p $RPM_BUILD_ROOT/etc/httpd/modules
  mkdir -p $RPM_BUILD_ROOT/var/log/httpd
  mkdir -p $RPM_BUILD_ROOT/var/run/php

  install -m 755 php_standalone $RPM_BUILD_ROOT%{_bindir}/php
  install -m 755 .libs/libphp4.so $RPM_BUILD_ROOT%{_libdir}/apache/
  install -m 755 .libs/libphp4.so $RPM_BUILD_ROOT/etc/httpd/modules/

  strip -g $RPM_BUILD_ROOT%{_libdir}/apache/*
  strip -g $RPM_BUILD_ROOT/etc/httpd/modules/*

  install -m 755 mysql.so $RPM_BUILD_ROOT%{_libdir}/php/extensions/
  install -m 755 imap.so $RPM_BUILD_ROOT%{_libdir}/php/extensions/

  strip -g $RPM_BUILD_ROOT%{_libdir}/php/extensions/*
  install -m 644 php.ini-dist $RPM_BUILD_ROOT/etc/php.ini

  touch $RPM_BUILD_ROOT/var/log/httpd/php_error.log

################################################################################
### SECTION:  scripts
################################################################################
%post -n mod_php
  %{__perl}  -pi -e 's|^#LoadModule php4_module        modules/libphp4.so|LoadModule php4_module        modules/libphp4.so|g' /etc/httpd/conf/httpd.conf
  %{__perl}  -pi -e 's|^#AddModule mod_php4.c|AddModule mod_php4.c|g' /etc/httpd/conf/httpd.conf
  %{__perl}  -pi -e 's|^#AddType application/x-httpd-php3 .php3|AddType application/x-httpd-php3 .php3|g' /etc/httpd/conf/httpd.conf
  %{__perl}  -pi -e 's|^#AddType application/x-httpd-php .php4|AddType application/x-httpd-php .php4|g' /etc/httpd/conf/httpd.conf
  %{__perl}  -pi -e 's|^#AddType application/x-httpd-php .php|AddType application/x-httpd-php .php|g' /etc/httpd/conf/httpd.conf

  # Ugly hack to fix my mistake (see 2000/11/22 changelog entry)
  %{__perl}  -pi -e 's|^LoadModule php4_module        modules/libphp4.so| LoadModule php4_module        modules/libphp4.so|g' /etc/httpd/conf/httpd.conf
  %{__perl}  -pi -e 's|^AddModule mod_php4.c| AddModule mod_php4.c|g' /etc/httpd/conf/httpd.conf
  %{__perl}  -pi -e 's|^AddType application/x-httpd-php3 .php3| AddType application/x-httpd-php3 .php3|g' /etc/httpd/conf/httpd.conf
  %{__perl}  -pi -e 's|^AddType application/x-httpd-php .php4| AddType application/x-httpd-php .php4|g' /etc/httpd/conf/httpd.conf
  %{__perl}  -pi -e 's|^AddType application/x-httpd-php .php| AddType application/x-httpd-php .php|g' /etc/httpd/conf/httpd.conf

  # Maybe restart Apache.
  if [ -f /var/lock/subsys/httpd ]; then
        /etc/init.d/httpd restart > /dev/null 2>&1 || :
  fi

%postun -n mod_php
  if [ $1 = 0 ]; then
	%{__perl}  -pi -e 's|^LoadModule php4_module        modules/libphp4.so|#LoadModule php4_module        modules/libphp4.so|g' /etc/httpd/conf/httpd.conf
	%{__perl}  -pi -e 's|^AddModule mod_php4.c|#AddModule mod_php4.c|g' /etc/httpd/conf/httpd.conf
	%{__perl}  -pi -e 's|^AddType application/x-httpd-php3 .php3|#AddType application/x-httpd-php3 .php3|g' /etc/httpd/conf/httpd.conf
	%{__perl}  -pi -e 's|^AddType application/x-httpd-php .php4|#AddType application/x-httpd-php .php4|g' /etc/httpd/conf/httpd.conf
	%{__perl}  -pi -e 's|^AddType application/x-httpd-php .php|#AddType application/x-httpd-php .php|g' /etc/httpd/conf/httpd.conf
  fi

  # Maybe restart Apache.
  if [ -f /var/lock/subsys/httpd ]; then
        /etc/init.d/httpd restart > /dev/null 2>&1 || :
  fi

%post mysql
  %{__perl} -pi -e "s|^;extension=mysql.so|extension=mysql.so|" /etc/php.ini

%preun mysql
  if [ $1 = 0 ] ; then
	%{__perl} -pi -e "s|^extension=mysql.so|;extension=mysql.so|" /etc/php.ini
  fi

%post imap
  %{__perl} -pi -e "s|^;extension=imap.so|extension=imap.so|" /etc/php.ini

%preun imap
  if [ $1 = 0 ] ; then
	%{__perl} -pi -e "s|^extension=imap.so|;extension=imap.so|" /etc/php.ini
  fi

################################################################################
### SECTION:  files
################################################################################
%files
  %defattr(-,root,root)
  %doc CODING_STANDARDS CREDITS INSTALL LICENSE
  %doc EXTENSIONS FUNCTION_LIST.txt TODO
  %doc NEWS README.* Zend/ZEND_*
  %config /etc/php.ini
  %{_bindir}/php
  %attr(700,webd,root) /var/run/php
  %attr(640,webd,root) /var/log/httpd/php_error.log

%files -n mod_php
  %defattr(-,root,root)
  %{_libdir}/apache/libphp4.so
  /etc/httpd/modules/libphp4.so

%files mysql
  %defattr(-,root,root)
  %{_libdir}/php/extensions/mysql.so

%files imap
  %defattr(-,root,root)
  %{_libdir}/php/extensions/imap.so


################################################################################
### SECTION:  clean
################################################################################
%clean
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT


################################################################################
### SECTION:  changelog
################################################################################
%changelog
* Thu Apr 10 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Release 1.3.0
  - Initial build for EnGarde Secure Community 2 (Feint).

* Wed Feb 19 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.2.3, Release 1.5.1
  - Bring in security updates for wordwrap() and CRLF injection from 1.2.

* Mon Feb 03 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Release 1.5.0
  - Initial build for EnGarde v1.5 (Thrust).

* Thu Dec 12 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.2.3, Release 1.2.4
  - (mysql) Security update brought on by auditing by some PHP folk.

* Tue Nov 19 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.2.3, Release 1.2.3
  - Update/upgrade candidate.
  - Restart apache (if it's running) in %post and %postun of mod_php.

* Wed Nov 13 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.2.3, Release 1.2.102
  - New upstream version.

* Thu Jul 11 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.2.1, Release 1.2.10[01]
  - BETA build for a ESP customer; if this release fixes the SquirrelMail bugs
    then it may be issued as an update in the near future.  Please do NOT
    distribute this package outside of authorized channels as it may not even
    work.

* Mon May 06 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.0.6, Release 1.2.2
  - Fix broken php.ini.

* Thu Apr 18 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.0.6, Release 1.2.1
  - Port a bunch of stuff forward from Balestra's errata package; see
    1.1.[67] changelog entry in Balestra for summary.

* Mon Feb 11 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Release 1.2.0
  - Initial build for EnGarde v1.2 (Parry).
  - Removed pre-EnGarde changelog.

* Wed Sep 19 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.0.5, Release 1.1.4
  - Hardcode extension_dir to '/usr/lib/php/extensions'.

* Tue Aug 14 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.0.5, Release 1.1.[23]
  - Rebuilt to get rid of the 'gdImageCreateFromGif'.  I think it was finding
      it from /usr/src/engarde/BUILD/gd1.3... must try to reproduce sometime.
  - Moved /usr/lib/php4 to /usr/lib/php.
  - Put the modules in /usr/lib/php/extensions.
  - Add the commented mysql.so and imap.so lines to the php.ini.

* Tue Aug 07 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.0.5, Release 1.1.1
  - Ryan-ized spec file.
  - Added several new configure options:
    - With Options:    --with-gd
    - Enable Options:  --enable-bcmath, --enable-calender, --enable-sockets.

* Tue Aug 07 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.0.5, Release 1.1.0
  - Initial build for EnGarde v1.1 (Balestra).
  - Moved the MySQL functionality out of "stock" php/mod_php and into the
      php-mysql package.
  - Added the php-imap package.

* Wed Mar 28 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.0.4pl1, Revision 1.0.15.
  - Rebuild against libmysqlclient.so.10

* Tue Jan 23 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.0.4pl1, Revision 1.0.14.
  - New version which fixes BTID# 2206.
  - Removed the 'manual' package.

* Fri Dec 29 2000 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.0.4, Revision 1.0.13.
  - Recompile against apache with pthreads.
  - Upgrade to 4.0.4.
  - Fixes PHP Bug ID #8298

* Thu Dec 07 2000 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.0.3pl1, Revision 1.0.5.
  - Trying to fix segfault, tweaked zlib in ./configure.

* Wed Nov 22 2000 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.0.3pl1, Revision 1.0.3.
- Put module in /etc/httpd/modules.
- It now auto-updates the httpd.conf on install and un-install.

* Tue Oct 31 2000 Ryan W. Maple <ryan@guardiandigital.com>
- Took out all the imap/pgsql/ldap stuff.
- Took out all the "unnecessary" compile-time options.
- Happy Halloween!
